package ru.dbotthepony.mc.otm.menu.tech

import net.minecraft.world.SimpleContainer
import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.block.entity.RedstoneSetting
import ru.dbotthepony.mc.otm.block.entity.tech.CobblerBlockEntity
import ru.dbotthepony.mc.otm.core.immutableList
import ru.dbotthepony.mc.otm.menu.MachineOutputSlot
import ru.dbotthepony.mc.otm.menu.MatteryMenu
import ru.dbotthepony.mc.otm.menu.input.EnumInputWithFeedback
import ru.dbotthepony.mc.otm.menu.input.ItemHandlerPlayerInput
import ru.dbotthepony.mc.otm.menu.widget.ProgressGaugeWidget
import ru.dbotthepony.mc.otm.registry.MMenus

class CobblerMenu @JvmOverloads constructor(
	p_38852_: Int,
	inventory: Inventory,
	tile: CobblerBlockEntity? = null
) : MatteryMenu(MMenus.COBBLESTONE_GENERATOR, p_38852_, inventory, tile) {
	val storageSlots = (tile?.container ?: SimpleContainer(CobblerBlockEntity.CONTAINER_SIZE)).let { c -> immutableList(c.containerSize) { addStorageSlot(MachineOutputSlot(c, it)) } }
	val redstone = EnumInputWithFeedback<RedstoneSetting>(this)
	val itemConfig = ItemHandlerPlayerInput(this, false, false)

	val progress: ProgressGaugeWidget

	init {
		if (tile == null)
			progress = ProgressGaugeWidget(this)
		else {
			progress = ProgressGaugeWidget(this, tile::workProgress, tile::isUnableToProcess)
			redstone.with(tile.redstoneControl::redstoneSetting)
			itemConfig.configure(tile.itemConfig)
		}

		addInventorySlots()
	}
}
